- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::ScaledMatrix Class Reference

Class for a Matrix in conjunction with its scaling factors for row and column scaling. More...

`#include <IpScaledMatrix.hpp>`

Inheritance diagram for Ipopt::ScaledMatrix:

[legend]
Collaboration diagram for Ipopt::ScaledMatrix:

[legend]
List of all members.

## Public Member Functions
void | SetUnscaledMatrix (const SmartPtr< const Matrix > unscaled_matrix)
| Set the unscaled matrix.
void | SetUnscaledMatrixNonConst (const SmartPtr< Matrix > &unscaled_matrix)
| Set the unscaled matrix in a non-const version.
SmartPtr< const Matrix > | GetUnscaledMatrix () const
| Return the unscaled matrix in const form.
SmartPtr< Matrix > | GetUnscaledMatrixNonConst ()
| Return the unscaled matrix in non-const form.
SmartPtr< const Vector > | RowScaling () const
| return the vector for the row scaling
SmartPtr< const Vector > | ColumnScaling () const
| return the vector for the column scaling
Constructors / Destructors
| ScaledMatrix (const ScaledMatrixSpace *owner_space)
| Constructor, taking the owner_space.
| ~ScaledMatrix ()
| Destructor.
## Protected Member Functions
Methods overloaded from Matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply.
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply.
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix.
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Compute the max-norm of the columns in the matrix.
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix.
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = beta*X + alpha*(Matrix S^{-1} Z).
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td).
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| ScaledMatrix ()
| Default Constructor.
| ScaledMatrix (const ScaledMatrix &)
| Copy Constructor.
void | operator= (const ScaledMatrix &)
| Overloaded Equals Operator.
## Private Attributes
SmartPtr< const Matrix > | matrix_
| const version of the unscaled matrix
SmartPtr< Matrix > | nonconst_matrix_
| non-const version of the unscaled matrix
SmartPtr< const ScaledMatrixSpace > | owner_space_
| Matrix space stored as a ScaledMatrixSpace.

## Detailed Description

Class for a Matrix in conjunction with its scaling factors for row and column scaling.

Operations on the matrix are performed using the scaled matrix. You can pull out the pointer to the unscaled matrix for unscaled calculations.

Definition at line 26 of file IpScaledMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::ScaledMatrix::ScaledMatrix | ( | const ScaledMatrixSpace * | owner_space | ) |

Constructor, taking the owner_space.

Ipopt::ScaledMatrix::~ScaledMatrix | ( |  | ) |

Destructor.

Ipopt::ScaledMatrix::ScaledMatrix | ( |  | ) | `[private]`

Default Constructor.

Ipopt::ScaledMatrix::ScaledMatrix | ( | const ScaledMatrix & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

void Ipopt::ScaledMatrix::SetUnscaledMatrix | ( | const SmartPtr< const Matrix > | unscaled_matrix | ) | `[inline]`

Set the unscaled matrix.

Definition at line 211 of file IpScaledMatrix.hpp.

References matrix_, nonconst_matrix_, and Ipopt::TaggedObject::ObjectChanged().

void Ipopt::ScaledMatrix::SetUnscaledMatrixNonConst | ( | const SmartPtr< Matrix > & | unscaled_matrix | ) | `[inline]`

Set the unscaled matrix in a non-const version.

Definition at line 219 of file IpScaledMatrix.hpp.

References Ipopt::GetRawPtr(), matrix_, nonconst_matrix_, and Ipopt::TaggedObject::ObjectChanged().

Referenced by Ipopt::ScaledMatrixSpace::MakeNewScaledMatrix().

SmartPtr< const Matrix > Ipopt::ScaledMatrix::GetUnscaledMatrix | ( |  | ) | const`[inline]`

Return the unscaled matrix in const form.

Definition at line 227 of file IpScaledMatrix.hpp.

References matrix_.

SmartPtr< Matrix > Ipopt::ScaledMatrix::GetUnscaledMatrixNonConst | ( |  | ) | `[inline]`

Return the unscaled matrix in non-const form.

Definition at line 233 of file IpScaledMatrix.hpp.

References DBG_ASSERT, Ipopt::IsValid(), nonconst_matrix_, and Ipopt::TaggedObject::ObjectChanged().

SmartPtr< const Vector > Ipopt::ScaledMatrix::RowScaling | ( |  | ) | const`[inline]`

return the vector for the row scaling

Definition at line 241 of file IpScaledMatrix.hpp.

References Ipopt::ConstPtr(), and owner_space_.

SmartPtr< const Vector > Ipopt::ScaledMatrix::ColumnScaling | ( |  | ) | const`[inline]`

return the vector for the column scaling

Definition at line 247 of file IpScaledMatrix.hpp.

References Ipopt::ConstPtr(), and owner_space_.

virtual void Ipopt::ScaledMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual void Ipopt::ScaledMatrix::TransMultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix(transpose) vector multiply.

Computes y = alpha * Matrix^T * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::ScaledMatrix::HasValidNumbersImpl | ( |  | ) | const`[protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

It is assumed that the scaling factors are valid.

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::ScaledMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init |
| ) |  |  | const`[protected, virtual]`

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::ScaledMatrix::ComputeColAMaxImpl | ( | Vector & | cols_norms,
|  | bool | init |
| ) |  |  | const`[protected, virtual]`

Compute the max-norm of the columns in the matrix.

The result is stored in cols_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::ScaledMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, virtual]`

Print detailed information about the matrix.

Implements Ipopt::Matrix.

virtual void Ipopt::ScaledMatrix::AddMSinvZImpl | ( | Number | alpha,
|  | const Vector & | S,
|  | const Vector & | Z,
|  | Vector & | X |
| ) |  |  | const`[protected, virtual]`

X = beta*X + alpha*(Matrix S^{-1} Z).

Specialized implementation missing so far!

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::ScaledMatrix::SinvBlrmZMTdBrImpl | ( | Number | alpha,
|  | const Vector & | S,
|  | const Vector & | R,
|  | const Vector & | Z,
|  | const Vector & | D,
|  | Vector & | X |
| ) |  |  | const`[protected, virtual]`

X = S^{-1} (r + alpha*Z*M^Td).

Specialized implementation missing so far!

Reimplemented from Ipopt::Matrix.

void Ipopt::ScaledMatrix::operator= | ( | const ScaledMatrix & |  | ) | `[private]`

Overloaded Equals Operator.

## Member Data Documentation

SmartPtr<const Matrix> Ipopt::ScaledMatrix::matrix_`[private]`

const version of the unscaled matrix

Definition at line 118 of file IpScaledMatrix.hpp.

Referenced by GetUnscaledMatrix(), SetUnscaledMatrix(), and SetUnscaledMatrixNonConst().

SmartPtr<Matrix> Ipopt::ScaledMatrix::nonconst_matrix_`[private]`

non-const version of the unscaled matrix

Definition at line 120 of file IpScaledMatrix.hpp.

Referenced by GetUnscaledMatrixNonConst(), SetUnscaledMatrix(), and SetUnscaledMatrixNonConst().

SmartPtr<const ScaledMatrixSpace> Ipopt::ScaledMatrix::owner_space_`[private]`

Matrix space stored as a ScaledMatrixSpace.

Reimplemented from Ipopt::Matrix.

Definition at line 123 of file IpScaledMatrix.hpp.

Referenced by ColumnScaling(), and RowScaling().

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.5.1/Ipopt/src/LinAlg/IpScaledMatrix.hpp